﻿Imports MindFusion.Charting.Wpf

Class Window1
    Private brushesList As BrushCollection
    Private r As Random = New Random()
    Private unlock As Boolean

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        Background = New LinearGradientBrush(Colors.SteelBlue, Colors.White, 0)

        pieChart3D.Series.Clear()

        'Initialize data		
        brushesList = New BrushCollection()
        Dim t As Byte = 200
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.DodgerBlue.Color.R, Brushes.DodgerBlue.Color.G, Brushes.DodgerBlue.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.Brown.Color.R, Brushes.Brown.Color.G, Brushes.Brown.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.Orange.Color.R, Brushes.Orange.Color.G, Brushes.Orange.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.Yellow.Color.R, Brushes.Yellow.Color.G, Brushes.Yellow.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.Green.Color.R, Brushes.Green.Color.G, Brushes.Green.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.Azure.Color.R, Brushes.Azure.Color.G, Brushes.Azure.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.LightSteelBlue.Color.R, Brushes.LightSteelBlue.Color.G, Brushes.LightSteelBlue.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.SteelBlue.Color.R, Brushes.SteelBlue.Color.G, Brushes.SteelBlue.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.DarkBlue.Color.R, Brushes.DarkBlue.Color.G, Brushes.DarkBlue.Color.B)))
        brushesList.Add(New SolidColorBrush(Color.FromArgb(t, _
            Brushes.DarkViolet.Color.R, Brushes.DarkViolet.Color.G, Brushes.DarkViolet.Color.B)))


        Dim serie As PieSeries = New PieSeries()
        serie.Data = New DoubleCollection(New Double() {25, 44, 72, 55, 37})
        serie.DetachedSlicesList = New DoubleCollection(New Double() {0, 0, 0, 0, 0})
        serie.OuterLabelType = LabelType.Percents
        serie.Fills = brushesList
        pieChart3D.Series.Add(serie)

        UpdatePieceSelection()
        pieceSelection.SelectedIndex = 0

        widthSlider.Value = 0.6
        heightSlider.Value = 0.1
        donSlider.Value = 1.0 / 3.0
        cornerSlider.Value = 1.0 / 2.5
        innerSlider.Value = serie.InnerLabelLocation
        serie.OuterLabelOffset = 25
        outerSlider.Value = serie.OuterLabelOffset
        unlock = True
    End Sub

    Private Sub UpdatePieceSelection()
        Dim j As Integer = pieceSelection.SelectedIndex
        pieceSelection.Items.Clear()
        For i As Integer = 0 To CType(pieChart3D.Series(0), PieSeries).Data.Count - 1
            pieceSelection.Items.Add("Piece " + i.ToString())
        Next

        If j >= CType(pieChart3D.Series(0), PieSeries).Data.Count Then
            j = CType(pieChart3D.Series(0), PieSeries).Data.Count - 1
        End If
        pieceSelection.SelectedIndex = j
    End Sub

    Private Sub Button_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        pieChart3D.BeginInit()
        Dim serie As PieSeries = CType(pieChart3D.Series(0), PieSeries)
        Dim d As Double = r.Next(15, 75)
        serie.Data.Add(d)
        serie.DetachedSlicesList.Add(0.0)
        If pieChart3D.SliceLayout = SliceLayout.Cascading Then
            pieChart3D.ModelHeight = (100.0 * heightSlider.Value) * serie.Data.Count
        Else
            pieChart3D.ModelHeight = 100.0 * heightSlider.Value
        End If
        UpdatePieceSelection()
        pieChart3D.EndInit()
    End Sub

    Private Sub Button_Click_1(ByVal sender As Object, ByVal e As RoutedEventArgs)
        pieChart3D.BeginInit()
        Dim serie As PieSeries = CType(pieChart3D.Series(0), PieSeries)
        If serie.Data.Count > 0 Then
            Dim g As Integer = serie.Data.Count - 1
            serie.Data.Remove(serie.Data(g))
            serie.DetachedSlicesList.Remove(serie.DetachedSlicesList(g))
        End If
        If (pieChart3D.SliceLayout = SliceLayout.Cascading) Then
            pieChart3D.ModelHeight = (100.0 * heightSlider.Value) * serie.Data.Count
        Else
            pieChart3D.ModelHeight = 100.0 * heightSlider.Value
        End If
        UpdatePieceSelection()
        pieChart3D.EndInit()
    End Sub

    Private Sub Slider_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        Dim serie As PieSeries = CType(pieChart3D.Series(0), PieSeries)
        serie.DetachedSlicesList(pieceSelection.SelectedIndex) = detachSlider.Value
        pieChart3D.UpdateChart()
    End Sub

    Private Sub cornerSlider_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        If unlock Then
            If Double.IsNaN(pieChart3D.ModelHeight) Then
                pieChart3D.CornerRadius3D = 5 * cornerSlider.Value
            Else
                pieChart3D.CornerRadius3D = (pieChart3D.ModelHeight / 2) * cornerSlider.Value
            End If
        End If
    End Sub

    Private Sub donSlider_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        If unlock Then
            If Double.IsNaN(pieChart3D.ModelWidth) Then
                pieChart3D.DoughnutThickness = 30 * donSlider.Value
            Else
                pieChart3D.DoughnutThickness = (pieChart3D.ModelWidth / 2) * donSlider.Value
            End If
        End If
    End Sub

    Private Sub roundCornerSelector_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        If Not unlock Then
            Return
        End If

        If roundCornerSelector.SelectedIndex = 0 Then
            pieChart3D.RoundCornerType = RoundCornerType.Top
        ElseIf roundCornerSelector.SelectedIndex = 1 Then
            pieChart3D.RoundCornerType = RoundCornerType.Bottom
        ElseIf roundCornerSelector.SelectedIndex = 2 Then
            pieChart3D.RoundCornerType = RoundCornerType.All
        ElseIf roundCornerSelector.SelectedIndex = 3 Then
            pieChart3D.RoundCornerType = RoundCornerType.None
        End If
    End Sub

    Private Sub squireSlider_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        If unlock Then
            pieChart3D.MeshFaceSize = 5.0 * squireSlider.Value + 0.5
        End If
    End Sub

    Private Sub widthSlider_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        If unlock Then
            pieChart3D.ModelWidth = 100.0 * widthSlider.Value
            pieChart3D.ModelDepth = 100.0 * widthSlider.Value
        End If
    End Sub

    Private Sub heightSlider_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        If unlock Then
            Dim serie As PieSeries = CType(pieChart3D.Series(0), PieSeries)
            If pieChart3D.SliceLayout = SliceLayout.Cascading Then
                pieChart3D.ModelHeight = (100.0 * heightSlider.Value) * serie.Data.Count
            Else
                pieChart3D.ModelHeight = 100.0 * heightSlider.Value
            End If
        End If
    End Sub

    Private Sub innerLabelSelector_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        If Not unlock Then
            Return
        End If
        If innerLabelSelector.SelectedIndex = 0 Then
            CType(pieChart3D.Series(0), PieSeries).InnerLabelType = LabelType.Percents
        ElseIf innerLabelSelector.SelectedIndex = 1 Then
            CType(pieChart3D.Series(0), PieSeries).InnerLabelType = LabelType.AutoScale
        ElseIf innerLabelSelector.SelectedIndex = 2 Then
            CType(pieChart3D.Series(0), PieSeries).InnerLabelType = LabelType.Empty
        End If
    End Sub

    Private Sub outerLabelSelector_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        If Not unlock Then
            Return
        End If
        If outerLabelSelector.SelectedIndex = 0 Then
            CType(pieChart3D.Series(0), PieSeries).OuterLabelType = LabelType.Percents
        ElseIf outerLabelSelector.SelectedIndex = 1 Then
            CType(pieChart3D.Series(0), PieSeries).OuterLabelType = LabelType.AutoScale
        ElseIf outerLabelSelector.SelectedIndex = 2 Then
            CType(pieChart3D.Series(0), PieSeries).OuterLabelType = LabelType.Empty
        End If
    End Sub

    Private Sub innerSlider_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        If unlock And Not CType(pieChart3D.Series(0), PieSeries).InnerLabelType = LabelType.Empty Then
            CType(pieChart3D.Series(0), PieSeries).InnerLabelLocation = innerSlider.Value
        End If
    End Sub

    Private Sub outerSlider_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        If unlock And Not CType(pieChart3D.Series(0), PieSeries).OuterLabelType = LabelType.Empty Then
            CType(pieChart3D.Series(0), PieSeries).OuterLabelOffset = outerSlider.Value
        End If
    End Sub

    Private Sub detachSelector_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        If Not unlock Then
            Return
        End If
        If detachSelector.SelectedIndex = 0 Then
            pieChart3D.DetachOrientation = Orientation.Horizontal
        ElseIf detachSelector.SelectedIndex = 1 Then
            pieChart3D.DetachOrientation = Orientation.Vertical
        End If
    End Sub

    Private Sub pieceLayoutSelector_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        If Not unlock Then
            Return
        End If
        pieChart3D.BeginInit()
        If pieceLayoutSelector.SelectedIndex = 0 Then
            pieChart3D.ModelHeight = 100.0 * heightSlider.Value
            pieChart3D.SliceLayout = SliceLayout.Flat
        ElseIf pieceLayoutSelector.SelectedIndex = 1 Then
            pieChart3D.ModelHeight = (100.0 * heightSlider.Value) * CType(pieChart3D.Series(0), PieSeries).Data.Count
            pieChart3D.SliceLayout = SliceLayout.Cascading
        End If
        pieChart3D.EndInit()
    End Sub

    Private Sub behavior_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs)
        If CType(sender, ComboBox).SelectedIndex = 0 Then
            pieChart3D.Behavior = Behavior3D.ChangePerspective
        Else
            pieChart3D.Behavior = Behavior3D.ChangeValue
        End If
    End Sub
End Class
